/*
 * cameraTest.h
 *
 *  Created on: 28 Jan 2025
 *      Author: user
 */
/*
#ifndef CAMERATEST_H_
#define CAMERATEST_H_

#include <stdint.h>
#include "fsl_adc16.h"
#include "fsl_ftm.h"
#include "fsl_gpio.h"

#define IMAGE_SIZE 128
#define THRESHOLD 3300
#define SI_CYCLE_LIMIT 200
#define TRACK_CENTER (IMAGE_SIZE/2)

AT_NONCACHEABLE_SECTION ( extern uint16_t camera_adc_output[IMAGE_SIZE]);
AT_NONCACHEABLE_SECTION ( extern uint16_t c_camera_adc_output[IMAGE_SIZE]);\
AT_NONCACHEABLE_SECTION ( extern uint16_t buffer[IMAGE_SIZE]);

extern int16_t prev_deviations[5];
extern int16_t camera_data_filtered[IMAGE_SIZE];
extern const float filter[];
extern volatile uint16_t current_pixel_number;
extern volatile int threshold;
extern uint16_t average;
extern volatile uint32_t right_filtered_value_max;
extern volatile uint32_t left_filtered_value_max;
extern uint16_t min_difference;
extern bool rightedge;
extern bool leftedge;
extern int leftindex;
extern int rightindex;
extern int middleindex;
extern int deviation;

void ADC1_IRQHANDLER(void);
void FTM1_IRQHANDLER(void);
void datawrite();
void calibrate_camera();
void convolution();
void edge_detection();
void deviationupdate();
void move();
int findTrackCenter(int *leftEdge, int *rightEdge);
void updateSteering(int leftEdge, int rightEdge);


#endif // CAMERATEST_H_
*/
